PROGRAM big_mem;
{ ========================= big_mem ============================
  Big_mem.pas benutzt die Unit BigHeap.  Aufrufe in BigHeap
  erlauben einem Programm, Heap-Platz in Blcken grer als
  65520 Byte zuzuweisen.
}

USES
	bigheap;

VAR
	allg_zeiger : POINTER;
	nachfrage   : LongInt;
	total       : LongInt;
	groesster   : LongInt;

BEGIN

	groesster := MaxAvail;
	Writeln( MemAvail, ' Byte sind insgesamt auf Heap verfgbar.' );
	Writeln( 'Grter zusammenhnger Block ist ', groesster, ' Byte.' );

	REPEAT
	Writeln( 'Sie knnen bis zu ', groesster, ' Byte zuweisen.' );
	Write( 'Wieviel Speicherblock mchten Sie zuweisen? ');
	Readln( nachfrage );
	IF (nachfrage > groesster) OR (nachfrage < 0)
		THEN Writeln( 'Dieser Betrag ist nicht verfgbar.' );
	UNTIL (nachfrage <= groesster) AND
	  (nachfrage >= 0);
	Writeln( 'Nachfrage: ', nachfrage, ' Byte.' );

	{ Nachfrage-Speicher. Dieser Aufruf benutzt bigheap.GetMem anstatt
	  System.GetMem. Dadurch kann man mehr als 65520 Byte zur gleichen
	  Zeit zuweisen.
	}
	GetMem( allg_zeiger, nachfrage );
	Writeln( 'Dies lt insgesamt ', MemAvail, ' Byte brig. ');
	Writeln( 'Dabei ist der grte Block ', MaxAvail, ' Byte gro.');

	Writeln( 'Platz freimachen...' );
	FreeMem( allg_zeiger, nachfrage );

END.




