
PROGRAM Sampler;

USES
	Crt, MSGraph;

CONST
	CRLF   = #13+#10;
	NFonts = 6;

	Textarten : ARRAY [1..2, 1..NFonts] OF CSTRING [8] =
	(
	('roman', 'courier', 'helv', 'tms rmn', 'modern', 'script'),
	('ROMAN', 'COURIER', 'HELV', 'TMS RMN', 'MODERN', 'SCRIPT')
	);

	Schriften : ARRAY [1..NFonts] OF CSTRING [12] =
		(
		' t''roman''',
		' t''cour''',
		' t''helv''',
		' t''tms rmn''',
		' t''modern''',
		' t''script'''
		);
	FontPfad : CSTRING = '*.FON';

VAR
	Liste   : CSTRING;
	Vc              : _VideoConfig;
	i, a            : Integer;
	Stra            : STRING[3];
	ch              : Char;


BEGIN
	{
		Lesen der Header-Informationen aus allen .FON-Dateien
		im aktuellen Verzeichnis
	}

	a := _RegisterFonts (FontPfad);
	IF a < 0 THEN
		BEGIN
		_OutText(' Fehler: Kein Eintragen der Fonts mglich ' +
				CRLF);
		Halt(0);
		END;

	a := _SetVideoMode(_MaxResMode);
	Str (a,Stra);
	_OutText (' MaxResMode = '+ Stra);

	_GetVideoConfig (Vc);

	FOR i:=1 TO NFonts DO
		BEGIN
		Liste :=Schriften[i] + 'bh30w24';
		a := _SetFont (Liste);
		IF (a <> -1) THEN
			BEGIN
			_SetColor (i+1);
			_MoveTo (0, i*30);
			_OutGText (Textarten[2,i]);
			_MoveTo (Vc.NumXPixels DIV 2, i*30);
			_OutGText (Textarten[1,i] + CRLF);
			END
		ELSE
			BEGIN
			a := _SetVideoMode (_DefaultMode);
			_OutText (' Fehler: Kann Font nicht setzen');
			Halt(1);
			END;
		END;
	ch := ReadKey;
	a := _SetVideoMode (_DefaultMode);
	_UnRegisterFonts;
END.

