
PROGRAM mathe;

{ MATHE.PAS demonstriert den Einsatz der mathematischen Funktionen, u.a.:

     Abs     Int    Odd          Round    Sqrt
     Exp     Ln     Random       Sqr      Trunc
     Frac    Pi     Randomize
}

CONST
   prog_name  = 'MATHE ';
   prog_zweck = 'demonstriert viele der mathematischen Routinen.';

VAR
   x,y : Real;
   i   : Integer;

BEGIN

   Writeln( prog_name, prog_zweck );
   Writeln;

   Write( 'Geben Sie eine reelle Zahl ein: ' );
   Readln( x );
   Writeln;
   Writeln( 'Funktion   Ergebnis ', x );
   Writeln( '--------   --------------------------------------------------' );
   y := Frac(x);
   Writeln( 'Frac       ', y:12:9 );
   y := Int(x);
   Writeln( 'Int        ', y:3:1 );
   y := Round( x );
   Writeln( 'Round      ', y );
   y := Trunc( x );
   Writeln( 'Trunc      ', y  );
   y:= Exp( x );
   Writeln( 'Exp        ', y );
   IF (x > 0.0) THEN
      BEGIN
	y:= Ln( x );
	Writeln( 'Ln         ', y )
      END;
   IF (x >= 0.0) THEN
      BEGIN
	y:= Sqrt( x );
	Writeln( 'Sqrt      ', y )
      END;
   y := Sqr( x );
   Writeln( 'Sqr       ', y );
   y := Abs( x );
   Writeln( 'Abs       ', y );
   Writeln;

   Writeln( 'Funktion   Ergebnis von PI = ', Pi:12:10 );
   Writeln( '--------   --------------------------------------------------' );
   Writeln( 'Frac       ', Frac( Pi ):12:9 );
   Writeln( 'Int        ', Int( Pi ):3:1 );
   Writeln( 'Round      ', Round( Pi ) );
   Writeln( 'Trunc      ', Trunc( Pi ) );
   Writeln( 'Exp        ', Exp( Pi ) );
   Writeln( 'Ln         ', Ln( Pi ) );
   Writeln( 'Sqrt       ', Sqrt( Pi ) );
   Writeln( 'Sqr        ', Sqr( Pi ) );
   Writeln( 'Abs        ', Abs( Pi ) );
   Writeln;

   Randomize;
   x := Random;
   Writeln;
   Writeln( 'Funktion   Ergebnis bei Zufallszahl ', x );
   Writeln( '--------   --------------------------------------------------' );
   Writeln( 'Frac       ', Frac( x ):12:9 );
   Writeln( 'Int        ', Int( x ):3:1 );
   Writeln( 'Round      ', Round( x ) );
   Writeln( 'Trunc      ', Trunc( x ) );
   Writeln( 'Exp        ', Exp( x ) );
   IF (x > 0.0) THEN
      Writeln( 'Ln         ', Ln( x ) );
   IF (x >= 0.0) THEN
      Writeln( 'Sqrt       ', Sqrt( x ) );
   Writeln( 'Sqr        ', Sqr( x ) );
   Writeln( 'Abs        ', Abs( x ) );
   Writeln;

   i := Random (50);
   Writeln( 'Funktion   Ergebnis bei einer Integer-Zufallszahl ', i );
   Writeln( '--------   --------------------------------------------------' );
   Writeln( 'Odd        ', Odd( i ) );
   Writeln( 'Exp        ', Exp( i ) );
   Writeln( 'Ln         ', Ln( i ) );
   Writeln( 'Sqrt       ', Sqrt( i ) );
   Writeln( 'Sqr        ', Sqr( i ) );
   Writeln( 'Abs        ', Abs( i ) );

END.

